Open a Hug
A daemon opens a Hug for one phase iteration of a run (an agent’s ctx.ask). spec is the
SDK’s HugSpec (title, prompt, context, requested_inputs, channels, expires_in_min,
reminders). CliqHub resolves the channels and posts the Hug to them. People the channels
reach who can’t view runs in the realm are left out and recorded; a Hug that reaches nobody
who could answer is refused. Retrying with the same hug_id returns the same Hug. Answers 201.
Requires a daemon’s realm token (cliq_dt_…) for the realm given by realm_id. Run in the realm; daemon of the realm.
curl --request POST \
--url https://{host}/v1/hugs/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"hug_id": "6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f",
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"phase": "approve",
"iteration": 0,
"spec": {
"title": "Review: approve",
"prompt": "Please review the fix.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [
{
"value": "approve"
},
{
"value": "reject"
}
]
}
],
"channels": [
"security"
],
"expires_in_min": 30
}
}
'import requests
url = "https://{host}/v1/hugs/create"
payload = {
"hug_id": "6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f",
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"phase": "approve",
"iteration": 0,
"spec": {
"title": "Review: approve",
"prompt": "Please review the fix.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [{ "value": "approve" }, { "value": "reject" }]
}
],
"channels": ["security"],
"expires_in_min": 30
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
hug_id: '6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f',
run_id: '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
daemon_id: '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
phase: 'approve',
iteration: 0,
spec: {
title: 'Review: approve',
prompt: 'Please review the fix.',
requested_inputs: [
{
name: 'decision',
type: 'enum',
choices: [{value: 'approve'}, {value: 'reject'}]
}
],
channels: ['security'],
expires_in_min: 30
}
})
};
fetch('https://{host}/v1/hugs/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/hugs/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'hug_id' => '6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f',
'run_id' => '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
'daemon_id' => '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'phase' => 'approve',
'iteration' => 0,
'spec' => [
'title' => 'Review: approve',
'prompt' => 'Please review the fix.',
'requested_inputs' => [
[
'name' => 'decision',
'type' => 'enum',
'choices' => [
[
'value' => 'approve'
],
[
'value' => 'reject'
]
]
]
],
'channels' => [
'security'
],
'expires_in_min' => 30
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/hugs/create"
payload := strings.NewReader("{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/hugs/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/hugs/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}"
response = http.request(request)
puts response.read_bodyAuthorizations
User PAT (cliq_tok_…, including session-scoped) or realm token (cliq_dt_…).
Body
The run asking.
1The daemon running it.
1The run's realm.
1The phase asking.
1The phase's iteration (0 first).
What it asks (the SDK's HugSpec).
Daemon-minted id; a retried create returns this Hug.
1 - 100curl --request POST \
--url https://{host}/v1/hugs/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"hug_id": "6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f",
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"phase": "approve",
"iteration": 0,
"spec": {
"title": "Review: approve",
"prompt": "Please review the fix.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [
{
"value": "approve"
},
{
"value": "reject"
}
]
}
],
"channels": [
"security"
],
"expires_in_min": 30
}
}
'import requests
url = "https://{host}/v1/hugs/create"
payload = {
"hug_id": "6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f",
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"phase": "approve",
"iteration": 0,
"spec": {
"title": "Review: approve",
"prompt": "Please review the fix.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [{ "value": "approve" }, { "value": "reject" }]
}
],
"channels": ["security"],
"expires_in_min": 30
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
hug_id: '6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f',
run_id: '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
daemon_id: '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
phase: 'approve',
iteration: 0,
spec: {
title: 'Review: approve',
prompt: 'Please review the fix.',
requested_inputs: [
{
name: 'decision',
type: 'enum',
choices: [{value: 'approve'}, {value: 'reject'}]
}
],
channels: ['security'],
expires_in_min: 30
}
})
};
fetch('https://{host}/v1/hugs/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/hugs/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'hug_id' => '6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f',
'run_id' => '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
'daemon_id' => '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'phase' => 'approve',
'iteration' => 0,
'spec' => [
'title' => 'Review: approve',
'prompt' => 'Please review the fix.',
'requested_inputs' => [
[
'name' => 'decision',
'type' => 'enum',
'choices' => [
[
'value' => 'approve'
],
[
'value' => 'reject'
]
]
]
],
'channels' => [
'security'
],
'expires_in_min' => 30
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/hugs/create"
payload := strings.NewReader("{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/hugs/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/hugs/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"hug_id\": \"6c2d1e0f-9a8b-4c7d-8e6f-5a4b3c2d1e0f\",\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"spec\": {\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the fix.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n }\n}"
response = http.request(request)
puts response.read_body